VERSION 5.00
Object = "{6B7E6392-850A-101B-AFC0-4210102A8DA7}#1.3#0"; "COMCTL32.OCX"
Begin VB.Form frmDetect 
   Caption         =   "Window Enumeration"
   ClientHeight    =   4170
   ClientLeft      =   60
   ClientTop       =   345
   ClientWidth     =   7620
   Icon            =   "WIN Enum.frx":0000
   LinkTopic       =   "Form1"
   ScaleHeight     =   4170
   ScaleWidth      =   7620
   StartUpPosition =   3  'Windows Default
   Begin VB.PictureBox picBanner 
      Align           =   1  'Align Top
      Appearance      =   0  'Flat
      BackColor       =   &H80000005&
      BorderStyle     =   0  'None
      ForeColor       =   &H80000008&
      Height          =   615
      Left            =   0
      MouseIcon       =   "WIN Enum.frx":1272
      MousePointer    =   99  'Custom
      Picture         =   "WIN Enum.frx":16B4
      ScaleHeight     =   615
      ScaleWidth      =   7620
      TabIndex        =   3
      Top             =   0
      Width           =   7620
   End
   Begin VB.CommandButton cmdRefresh 
      Caption         =   "&Refresh"
      Height          =   375
      Left            =   120
      TabIndex        =   1
      Top             =   720
      Width           =   2055
   End
   Begin VB.CheckBox chkInclude 
      Caption         =   "Include Hidden Windows"
      Height          =   375
      Left            =   2280
      TabIndex        =   2
      Top             =   720
      Width           =   2895
   End
   Begin ComctlLib.TreeView tvwWindows 
      Height          =   2895
      Left            =   120
      TabIndex        =   0
      Top             =   1200
      Width           =   7455
      _ExtentX        =   13150
      _ExtentY        =   5106
      _Version        =   327682
      Indentation     =   353
      LabelEdit       =   1
      LineStyle       =   1
      PathSeparator   =   "/"
      Sorted          =   -1  'True
      Style           =   7
      ImageList       =   "ilsIcons"
      BorderStyle     =   1
      Appearance      =   1
   End
End
Attribute VB_Name = "frmDetect"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Option Explicit

'==================================================================
'
' Window Enumeration Dialog
'
' 30 September 2001
'
' You're free in using this software, as long as the
' orignal copyright/author information remains intact.
' In other words, respecting the person(s) who made it
' possible for you to view/learn something of this software.
'
' Copyright  2001 - Diederik van der Boor
' http://www.codingdomain.com
'
'==================================================================


'------------------------------------------------------------------
' Make object and start enum

Private WithEvents WinTreeEnum As WindowEnums
Attribute WinTreeEnum.VB_VarHelpID = -1

Private Sub Form_Initialize()
  Set WinTreeEnum = New WindowEnums
  Call cmdRefresh_Click
End Sub


'------------------------------------------------------------------
' Misc Form Stuff

Private Sub Form_Resize()
  If Me.WindowState <> vbMinimized Then
    tvwWindows.Width = Me.ScaleWidth - tvwWindows.Left - 100
    tvwWindows.Height = Me.ScaleHeight - tvwWindows.Top - 100
  End If
End Sub

Private Sub Form_Activate()
  cmdRefresh.SetFocus
End Sub


'------------------------------------------------------------------
' Enumerate!

Private Sub cmdRefresh_Click()
  Dim I As Long
  
  ' Clear treeview (Backwards because items will be (re)moved)
  For I = tvwWindows.Nodes.Count To 1 Step -1
    Call tvwWindows.Nodes.Remove(I)
  Next
  
  ' Start search for (child)windows
  Call WinTreeEnum.EnumWindows
End Sub


'------------------------------------------------------------------
' Events from the enumeration object

Private Sub WinTreeEnum_GotWindow(ByVal hWnd As Long, ContinueEnum As Boolean)
  Dim Node As Node
  Dim ClassName As String
  Dim Caption As String
  
  If WindowVisible(hWnd) Or chkInclude.Value Then
    ' ClassName
    ClassName = WindowClassName(hWnd)
    
    ' Add node
    Set Node = tvwWindows.Nodes.Add(, , ClassName & " " & hWnd)
    Caption = WindowCaption(hWnd)
    Node.Text = ClassName & " = " & IIf(Len(Caption), Caption, " (No Title)")
    
    On Error Resume Next
      Call WinTreeEnum.EnumChildWindows(hWnd) ' Error when no child windows found
    On Error GoTo 0
  End If
  
  ContinueEnum = True
End Sub

Private Sub WinTreeEnum_GotChildWindow(ByVal hWnd As Long, ByVal ParenthWnd As Long, ContinueEnum As Boolean)
  Dim ClassName1 As String, ClassName2 As String, Caption As String
  Dim Node As Node
  
  If WindowVisible(hWnd) Or chkInclude.Value Then
    ClassName1 = WindowClassName(hWnd)
    ClassName2 = WindowClassName(ParenthWnd)
    
    ' Add node
    Set Node = tvwWindows.Nodes.Add((ClassName2 & " " & ParenthWnd), tvwChild, (ClassName1 & " " & hWnd))
    
    ' Update caption-text if changed
    Caption = WindowCaption(hWnd)
    Node.Text = ClassName1 & " = " & IIf(Len(Caption), Caption, " (No Title)")
  End If
  
  ContinueEnum = True
End Sub



'------------------------------------------------------------------
' Banner

Private Sub picBanner_Click()
  MsgBox "Copyright  2001 - Diederik van der Boor" & vbCrLf _
       & vbCrLf _
       & "Anyone is allowed to use this software freely, as long as" & vbCrLf _
       & "the the copright information in the source code remains intact." & vbCrLf _
       & vbCrLf _
       & "http://www.codingdomain.com"
End Sub


