VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "WindowEnums"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False
Attribute VB_Description = "Helper class for enumerating windows."
Attribute VB_Ext_KEY = "SavedWithClassBuilder6" ,"Yes"
Attribute VB_Ext_KEY = "Top_Level" ,"Yes"
Option Explicit

'==================================================================
'
' Window Enumeration Class
'
' 30 September 2001
'
' You're free in using this software, as long as the
' orignal copyright/author information remains intact.
' In other words, respecting the person(s) who made it
' possible for you to view/learn something of this software.
'
' Copyright  2001 - Diederik van der Boor
' http://www.codingdomain.com
'
'==================================================================



'------------------------------------------------------------------------
' Declarations

Public Event GotWindow(ByVal hWnd As Long, ByRef ContinueEnum As Boolean)
Public Event GotChildWindow(ByVal hWnd As Long, ByVal ParenthWnd As Long, ByRef ContinueEnum As Boolean)

Private Declare Function EnumWindows_Api Lib "user32.dll" Alias "EnumWindows" (ByVal lpEnumFunc As Long, ByVal lParam As Long) As Long
Private Declare Function EnumChildWindows_Api Lib "user32" Alias "EnumChildWindows" (ByVal hWndParent As Long, ByVal lpEnumFunc As Long, ByVal lParam As Long) As Long
Private Declare Function GetParent Lib "user32" (ByVal hWnd As Long) As Long


'------------------------------------------------------------------------
' Run a certain enumeration:

Public Sub EnumWindows()
  If EnumWindows_Api(AddressOf EnumWindows_CallBack, ObjPtr(Me)) = 0 Then _
    Err.Raise 12345, "WindowsEnum", "Could not enumerate all windows!"
End Sub

Public Sub EnumChildWindows(ByVal ParenthWnd As Long)
  If EnumChildWindows_Api(ParenthWnd, AddressOf EnumChildWindows_CallBack, ObjPtr(Me)) = 0 Then _
    Err.Raise 12345, "WindowsEnum", "Could not enumerate all child windows!"
End Sub


'------------------------------------------------------------------------
' Hidden communication routines

Friend Function RaiseEventGW(ByVal hWnd As Long) As Long
  Dim ContinueEnum As Boolean
  RaiseEvent GotWindow(hWnd, ContinueEnum)
  RaiseEventGW = IIf(ContinueEnum, 1, 0)
End Function

Friend Function RaiseEventGCW(ByVal hWnd As Long) As Long
  Dim ContinueEnum As Boolean
  RaiseEvent GotChildWindow(hWnd, GetParent(hWnd), ContinueEnum)
  RaiseEventGCW = IIf(ContinueEnum, 1, 0)
End Function

